-module(id_server).

-export([start/0,
         get_id/0,
         code_upgrade/0,
         stop/0]).

% Internal export
-export([loop/1]).

start() ->
    spawn_link(fun() ->
                       register(id_server, self()),
                       loop(0)
               end).

stop() ->
    id_server ! stop.

code_upgrade() ->
    id_server ! code_upgrade.

get_id() ->
    id_server ! {get_id, self()},
    receive
        {id, Id} ->
            Id
    end.

loop(NextId) ->
    receive
        {get_id, Pid} ->
            Pid ! {id, NextId},
            loop(NextId + 2);
        code_upgrade ->
            ?MODULE:loop(NextId);
        stop ->
            ok
    end.
        
