-module(id_sup).

-behaviour(supervisor).

%% API
-export([start_link/0]).

%% Supervisor callbacks
-export([init/1]).

-define(SERVER, ?MODULE).
-define(TIMEOUT, 5000). % 5 seconds

%%%=============================================================================
%%% API functions
%%%=============================================================================

start_link() ->
    supervisor:start_link({local, ?SERVER}, ?MODULE, []).

%%%=============================================================================
%%% Supervisor callbacks
%%%=============================================================================

init([]) ->
    {ok, { {one_for_one, 5, 10},
          [
           child(id_server2)
          ]}}.

%%%=============================================================================
%%% Internal functions
%%%=============================================================================

child(Mod) ->
    {Mod, {Mod, start_link, []}, permanent, ?TIMEOUT, worker, [Mod]}.
